	/*
		Simple DirectX 11

		File:		Class_Direct3D.h
		Version:	0.1
		Author:		Nero

		Referenzen:
		http://www.directxtutorial.com/Tutorial11/tutorials.aspx
		http://www.rastertek.com/tutdx11.html	
		http://msdn.microsoft.com/en-us/library/windows/desktop/ee663274%28v=vs.85%29.aspx
	*/

	#pragma once

	#include <System_Includes.h>

	class sdx_Direct3D
	{
		public:
			sdx_Direct3D::sdx_Direct3D();
			sdx_Direct3D::~sdx_Direct3D();

		public:
			HRESULT						sdx_D3D_Error;

		public:
			HRESULT						sdx_D3D_InitScreen(D3DAdapterSettings *);
			void						sdx_D3D_FreeScreen(void);
			void						sdx_D3D_ClearScreen(DWORD Color);
			void						sdx_D3D_FlipBuffers(void);


		public:
			ID3D11Device			*  sdx_D3D_GetDevice();



		private:
			IDXGIFactory1			*	sdx_D3D_Factory;
			IDXGIAdapter1			*	sdx_D3D_Adapter;
			IDXGIOutput				*	sdx_D3D_Output;
			IDXGISwapChain			*	sdx_D3D_SwapChain;
			ID3D11Device			*	sdx_D3D_Device;
			ID3D11DeviceContext		*	sdx_D3D_DeviceContext;
			D3D_FEATURE_LEVEL			sdxFeatureLvl;
			ID3D11RenderTargetView	*	sdx_D3D_RenderTargetView;
			ID3D11Texture2D			*	sdx_D3D_DepthStencilBuffer;
			ID3D11DepthStencilState	*	sdx_D3D_DepthStencilState;			
			ID3D11DepthStencilView	*	sdx_D3D_DepthStencilView;
			ID3D11RasterizerState	*	sdx_D3D_RasterState;
			D3DXMATRIX					sdx_D3D_ProjectionMatrix;
			D3DXMATRIX					sdx_D3D_WorldMatrix;
			D3DXMATRIX					sdx_D3D_OrthoMatrix;
			bool						sdx_D3D_FullScreen;
			bool						sdx_D3D_VSync;


	};